diff --git a/include/sys/stat.h b/include/sys/stat.h
index 87d4a5ec4f..da8b14fee0 100644
--- a/include/sys/stat.h
+++ b/include/sys/stat.h
@@ -84,6 +84,8 @@ extern __mode_t __umask (__mode_t __mask);
 extern int __mkdir (const char *__path, __mode_t __mode);
 libc_hidden_proto (__mkdir)
 
+extern int __mknodat_common (int fd, const char *, __mode_t, __dev_t *)
+  attribute_hidden;
 extern int __mknodat (int fd, const char *path, mode_t mode, dev_t dev);
 libc_hidden_proto (__mknodat);
 extern int __mknod (const char *__path,
@@ -92,10 +94,8 @@ libc_hidden_proto (__mknod);
 
 extern int __xmknod (int __ver, const char *__path, __mode_t __mode,
 		     __dev_t *__dev);
-libc_hidden_proto (__xmknod)
 extern int __xmknodat (int __ver, int __fd, const char *__path,
 		       __mode_t __mode, __dev_t *__dev);
-libc_hidden_proto (__xmknodat)
 
 int __fxstat (int __ver, int __fildes, struct stat *__stat_buf);
 int __xstat (int __ver, const char *__filename,
@@ -121,6 +121,8 @@ hidden_proto (__xstat64);
 hidden_proto (__lxstat64);
 hidden_proto (__fxstatat64);
 #  endif
+libc_hidden_proto (__xmknod)
+libc_hidden_proto (__xmknodat)
 #  define stat(fname, buf) __xstat (_STAT_VER, fname, buf)
 #  define lstat(fname, buf)  __lxstat (_STAT_VER, fname, buf)
 #  define __lstat(fname, buf)  __lxstat (_STAT_VER, fname, buf)
diff --git a/sysdeps/mach/hurd/xmknod.c b/sysdeps/mach/hurd/xmknod.c
index 0ab4f1b719..67e32f518d 100644
--- a/sysdeps/mach/hurd/xmknod.c
+++ b/sysdeps/mach/hurd/xmknod.c
@@ -30,4 +30,3 @@ __xmknod (int vers, const char *file_name, mode_t mode, dev_t *dev)
 {
   return __xmknodat (vers, AT_FDCWD, file_name, mode, dev);
 }
-libc_hidden_def (__xmknod)
diff --git a/sysdeps/mach/hurd/xmknodat.c b/sysdeps/mach/hurd/xmknodat.c
index 4239d1ea91..0333765ebc 100644
--- a/sysdeps/mach/hurd/xmknodat.c
+++ b/sysdeps/mach/hurd/xmknodat.c
@@ -116,5 +116,3 @@ __xmknodat (int vers, int fd, const char *path, mode_t mode, dev_t *dev)
     return __hurd_fail (err);
   return 0;
 }
-
-libc_hidden_def (__xmknodat)
diff --git a/sysdeps/unix/sysv/linux/mknod.c b/sysdeps/unix/sysv/linux/mknod.c
new file mode 100644
index 0000000000..3185726f52
--- /dev/null
+++ b/sysdeps/unix/sysv/linux/mknod.c
@@ -0,0 +1,28 @@
+/* Create a special or ordinary file.  Linux version.
+   Copyright (C) 2020 Free Software Foundation, Inc.
+   This file is part of the GNU C Library.
+
+   The GNU C Library is free software; you can redistribute it and/or
+   modify it under the terms of the GNU Lesser General Public
+   License as published by the Free Software Foundation; either
+   version 2.1 of the License, or (at your option) any later version.
+
+   The GNU C Library is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+   Lesser General Public License for more details.
+
+   You should have received a copy of the GNU Lesser General Public
+   License along with the GNU C Library; if not, see
+   <https://www.gnu.org/licenses/>.  */
+
+#include <sys/stat.h>
+#include <fcntl.h>
+
+int
+__mknod (const char *path, mode_t mode, dev_t dev)
+{
+  return __mknodat_common (AT_FDCWD, path, mode, &dev);
+}
+libc_hidden_def (__mknod)
+weak_alias (__mknod, mknod)
diff --git a/sysdeps/unix/sysv/linux/mknodat.c b/sysdeps/unix/sysv/linux/mknodat.c
new file mode 100644
index 0000000000..d160fe520b
--- /dev/null
+++ b/sysdeps/unix/sysv/linux/mknodat.c
@@ -0,0 +1,41 @@
+/* Create a special or ordinary file.  Linux version.
+   Copyright (C) 2020 Free Software Foundation, Inc.
+   This file is part of the GNU C Library.
+
+   The GNU C Library is free software; you can redistribute it and/or
+   modify it under the terms of the GNU Lesser General Public
+   License as published by the Free Software Foundation; either
+   version 2.1 of the License, or (at your option) any later version.
+
+   The GNU C Library is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+   Lesser General Public License for more details.
+
+   You should have received a copy of the GNU Lesser General Public
+   License along with the GNU C Library; if not, see
+   <https://www.gnu.org/licenses/>.  */
+
+#include <sys/types.h>
+#include <sys/stat.h>
+#include <errno.h>
+
+int
+__mknodat_common (int fd, const char *path, mode_t mode, dev_t *dev)
+{
+  /* We must convert the value to dev_t type used by the kernel.  */
+  unsigned long long int k_dev = (*dev) & ((1ULL << 32) - 1);
+  if (k_dev != *dev)
+    return INLINE_SYSCALL_ERROR_RETURN_VALUE (EINVAL);
+
+  return INLINE_SYSCALL_CALL (mknodat, fd, path, mode,
+			      (unsigned int) k_dev);
+}
+
+int
+__mknodat (int fd, const char *path, mode_t mode, dev_t dev)
+{
+  return __mknodat_common (fd, path, mode, &dev);
+}
+libc_hidden_def (__mknodat)
+weak_alias (__mknodat, mknodat)
diff --git a/sysdeps/unix/sysv/linux/xmknod.c b/sysdeps/unix/sysv/linux/xmknod.c
index 42809d4c57..2ae384a536 100644
--- a/sysdeps/unix/sysv/linux/xmknod.c
+++ b/sysdeps/unix/sysv/linux/xmknod.c
@@ -17,29 +17,23 @@
    <https://www.gnu.org/licenses/>.  */
 
 #include <sys/stat.h>
-#include <sys/sysmacros.h>
 #include <fcntl.h>
-#include <sysdep.h>
+#include <errno.h>
+#include <shlib-compat.h>
 
+#if SHLIB_COMPAT(libc, GLIBC_2_0, GLIBC_2_33)
 /* Create a device file named PATH, with permission and special bits MODE
    and device number DEV (which can be constructed from major and minor
    device numbers with the `makedev' macro above).  */
 int
+attribute_compat_text_section
 __xmknod (int vers, const char *path, mode_t mode, dev_t *dev)
 {
-  unsigned long long int k_dev;
-
   if (vers != _MKNOD_VER)
     return INLINE_SYSCALL_ERROR_RETURN_VALUE (EINVAL);
 
-  /* We must convert the value to dev_t type used by the kernel.  */
-  k_dev =  (*dev) & ((1ULL << 32) - 1);
-  if (k_dev != *dev)
-    return INLINE_SYSCALL_ERROR_RETURN_VALUE (EINVAL);
-
-  return INLINE_SYSCALL_CALL (mknodat, AT_FDCWD, path, mode,
-			      (unsigned int) k_dev);
+  return __mknodat_common (AT_FDCWD, path, mode, dev);
 }
 
-weak_alias (__xmknod, _xmknod)
-libc_hidden_def (__xmknod)
+compat_symbol (libc, __xmknod, __xmknod, GLIBC_2_0);
+#endif
diff --git a/sysdeps/unix/sysv/linux/xmknodat.c b/sysdeps/unix/sysv/linux/xmknodat.c
index 5640a499aa..11b52a29b2 100644
--- a/sysdeps/unix/sysv/linux/xmknodat.c
+++ b/sysdeps/unix/sysv/linux/xmknodat.c
@@ -15,18 +15,11 @@
    License along with the GNU C Library; if not, see
    <https://www.gnu.org/licenses/>.  */
 
-#include <errno.h>
-#include <fcntl.h>
-#include <stdio.h>
-#include <string.h>
-#include <sys/types.h>
 #include <sys/stat.h>
-#include <sys/sysmacros.h>
-
-#include <sysdep.h>
-#include <sys/syscall.h>
-
+#include <errno.h>
+#include <shlib-compat.h>
 
+#if SHLIB_COMPAT(libc, GLIBC_2_4, GLIBC_2_33)
 /* Create a device file named PATH relative to FD, with permission and
    special bits MODE and device number DEV (which can be constructed
    from major and minor device numbers with the `makedev' macro above).  */
@@ -36,12 +29,8 @@ __xmknodat (int vers, int fd, const char *file, mode_t mode, dev_t *dev)
   if (vers != _MKNOD_VER)
     return INLINE_SYSCALL_ERROR_RETURN_VALUE (EINVAL);
 
-  /* We must convert the value to dev_t type used by the kernel.  */
-  unsigned long long int k_dev =  (*dev) & ((1ULL << 32) - 1);
-  if (k_dev != *dev)
-    return INLINE_SYSCALL_ERROR_RETURN_VALUE (EINVAL);
-
-  return INLINE_SYSCALL (mknodat, 4, fd, file, mode, (unsigned int) k_dev);
+  return __mknodat_common (fd, file, mode, dev);
 }
 
-libc_hidden_def (__xmknodat)
+compat_symbol (libc, __xmknodat, __xmknodat, GLIBC_2_4);
+#endif